From e881ba846ac5c2545f33be7d03cfc5b062d266f9 Mon Sep 17 00:00:00 2001
From: Alexander Golubev <fatzer2@gmail.com>
Date: Tue, 24 Sep 2013 23:26:59 +0400
Subject: [PATCH] add operator-> list iterators

---
 src/tools/ntqptrlist.h   | 9 ++++-----
 src/tools/ntqvaluelist.h | 6 ++----
 2 files changed, 6 insertions(+), 9 deletions(-)

diff --git a/src/tools/ntqptrlist.h b/src/tools/ntqptrlist.h
index 4482d0a..8a1a80d 100644
--- a/src/tools/ntqptrlist.h
+++ b/src/tools/ntqptrlist.h
@@ -49,6 +49,7 @@ class TQPtrListStdIterator : public TQGListStdIterator
 public:
     inline TQPtrListStdIterator( TQLNode* n ): TQGListStdIterator(n) {}
     type *operator*() { return node ? (type *)node->getData() : 0; }
+    type *operator->() { return node ? (type *)node->getData() : 0; }
     inline TQPtrListStdIterator<type> operator++()
     { node = next(); return *this; }
     inline TQPtrListStdIterator<type> operator++(int)
@@ -168,11 +169,9 @@ public:
     operator type *() const   { return (type *)TQGListIterator::get(); }
     type *operator*()         { return (type *)TQGListIterator::get(); }
 
-    // No good, since TQPtrList<char> (ie. TQStrList fails...
-    //
-    // MSVC++ gives warning
-    // Sunpro C++ 4.1 gives error
-    //    type *operator->()        { return (type *)TQGListIterator::get(); }
+    // TODO here was some sort of malfunctions in different compillers,
+    //      so check it yet another time (2013-09-24, 08:08, Fat-Zer)
+    type *operator->()        { return (type *)TQGListIterator::get(); }
 
     type *current()   const   { return (type *)TQGListIterator::get(); }
     type *operator()()	      { return (type *)TQGListIterator::operator()();}
diff --git a/src/tools/ntqvaluelist.h b/src/tools/ntqvaluelist.h
index 91d50c9..b2e9cd5 100644
--- a/src/tools/ntqvaluelist.h
+++ b/src/tools/ntqvaluelist.h
@@ -112,8 +112,7 @@ class TQValueListIterator
     bool operator!=( const TQValueListIterator<T>& it ) const { return node != it.node; }
     const T& operator*() const { return node->data; }
     T& operator*() { return node->data; }
-    // UDT for T = x*
-    // T* operator->() const { return &node->data; }
+    T* operator->() const { return &node->data; }
 
     TQValueListIterator<T>& operator++() {
 	node = node->next;
@@ -188,8 +187,7 @@ class TQValueListConstIterator
     bool operator==( const TQValueListConstIterator<T>& it ) const { return node == it.node; }
     bool operator!=( const TQValueListConstIterator<T>& it ) const { return node != it.node; }
     const T& operator*() const { return node->data; }
-    // UDT for T = x*
-    // const T* operator->() const { return &node->data; }
+    const T* operator->() const { return &node->data; }
 
     TQValueListConstIterator<T>& operator++() {
 	node = node->next;
-- 
1.8.1.5

